"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runHandler = exports.runAndroid = exports.restoreIOSUI = exports.runIOS = void 0;
var path_1 = __importDefault(require("path"));
var execa_1 = __importDefault(require("execa"));
var fs_1 = require("fs");
var screenshot_1 = require("../screenshot");
var report_1 = require("../report");
var config_1 = require("./config");
var logger_1 = require("../logger");
var wait_for_1 = require("../utils/wait-for");
var runIOS = function (config, logger) { return __awaiter(void 0, void 0, void 0, function () {
    var stdio, DEFAULT_BINARY_DIR, cwd, appFilename, plistPath, simulator, bundleId, SIMULATOR_TIME, setTimeCommand, installCommand, launchCommand, appearanceCommand;
    var _a, _b, _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                stdio = config.debug ? 'inherit' : 'ignore';
                DEFAULT_BINARY_DIR = "/ios/build/Build/Products/" + ((_a = config.ios) === null || _a === void 0 ? void 0 : _a.configuration) + "-iphonesimulator";
                cwd = ((_b = config.ios) === null || _b === void 0 ? void 0 : _b.binaryPath)
                    ? path_1.default.dirname((_c = config.ios) === null || _c === void 0 ? void 0 : _c.binaryPath)
                    : path_1.default.join(process.cwd(), DEFAULT_BINARY_DIR);
                appFilename = config.ios.binaryPath
                    ? path_1.default.basename(config.ios.binaryPath)
                    : config.ios.scheme + ".app";
                plistPath = path_1.default.join(cwd, appFilename, 'Info.plist');
                simulator = config.ios.device.replace(/([ /])/g, '\\$1');
                return [4 /*yield*/, execa_1.default.command("./PlistBuddy -c 'Print CFBundleIdentifier' " + plistPath, { shell: true, cwd: '/usr/libexec' })];
            case 1:
                bundleId = (_d.sent()).stdout;
                logger.print("[OWL - CLI] Found bundle id: " + bundleId);
                SIMULATOR_TIME = '9:41';
                setTimeCommand = "xcrun simctl status_bar " + simulator + " override --time " + SIMULATOR_TIME;
                return [4 /*yield*/, execa_1.default.command(setTimeCommand, { stdio: stdio, cwd: cwd })];
            case 2:
                _d.sent();
                installCommand = "xcrun simctl install " + simulator + " " + appFilename;
                return [4 /*yield*/, execa_1.default.command(installCommand, { stdio: stdio, cwd: cwd })];
            case 3:
                _d.sent();
                launchCommand = "xcrun simctl launch " + simulator + " " + bundleId;
                return [4 /*yield*/, execa_1.default.command(launchCommand, { stdio: stdio })];
            case 4:
                _d.sent();
                return [4 /*yield*/, (0, wait_for_1.waitFor)(1000)];
            case 5:
                _d.sent();
                appearanceCommand = "xcrun simctl ui " + simulator + " appearance";
                return [4 /*yield*/, execa_1.default.command(appearanceCommand + " dark", { stdio: stdio, cwd: cwd })];
            case 6:
                _d.sent();
                return [4 /*yield*/, (0, wait_for_1.waitFor)(500)];
            case 7:
                _d.sent();
                return [4 /*yield*/, execa_1.default.command(appearanceCommand + " light", { stdio: stdio, cwd: cwd })];
            case 8:
                _d.sent();
                return [4 /*yield*/, (0, wait_for_1.waitFor)(500)];
            case 9:
                _d.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.runIOS = runIOS;
var restoreIOSUI = function (config, logger) { return __awaiter(void 0, void 0, void 0, function () {
    var stdio, DEFAULT_BINARY_DIR, cwd, simulator, restoreTimeCommand;
    var _a, _b, _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                stdio = config.debug ? 'inherit' : 'ignore';
                DEFAULT_BINARY_DIR = "/ios/build/Build/Products/" + ((_a = config.ios) === null || _a === void 0 ? void 0 : _a.configuration) + "-iphonesimulator";
                cwd = ((_b = config.ios) === null || _b === void 0 ? void 0 : _b.binaryPath)
                    ? path_1.default.dirname((_c = config.ios) === null || _c === void 0 ? void 0 : _c.binaryPath)
                    : path_1.default.join(process.cwd(), DEFAULT_BINARY_DIR);
                simulator = config.ios.device.replace(/([ /])/g, '\\$1');
                restoreTimeCommand = "xcrun simctl status_bar " + simulator + " clear";
                return [4 /*yield*/, execa_1.default.command(restoreTimeCommand, { stdio: stdio, cwd: cwd })];
            case 1:
                _d.sent();
                logger.print("[OWL - CLI] Restored status bar time");
                return [2 /*return*/];
        }
    });
}); };
exports.restoreIOSUI = restoreIOSUI;
var runAndroid = function (config, logger) { return __awaiter(void 0, void 0, void 0, function () {
    var stdio, buildType, DEFAULT_APK_DIR, cwd, appFilename, appPath, packageName, installCommand, launchCommand;
    var _a, _b, _c, _d;
    return __generator(this, function (_e) {
        switch (_e.label) {
            case 0:
                stdio = config.debug ? 'inherit' : 'ignore';
                buildType = (_b = (_a = config.android) === null || _a === void 0 ? void 0 : _a.buildType) === null || _b === void 0 ? void 0 : _b.toLowerCase();
                DEFAULT_APK_DIR = "/android/app/build/outputs/apk/" + buildType + "/";
                cwd = ((_c = config.android) === null || _c === void 0 ? void 0 : _c.binaryPath)
                    ? path_1.default.dirname((_d = config.android) === null || _d === void 0 ? void 0 : _d.binaryPath)
                    : path_1.default.join(process.cwd(), DEFAULT_APK_DIR);
                appFilename = config.android.binaryPath
                    ? path_1.default.basename(config.android.binaryPath)
                    : "app-" + buildType + ".apk";
                appPath = path_1.default.join(cwd, appFilename);
                packageName = config.android.packageName;
                installCommand = "adb install -r " + appPath;
                return [4 /*yield*/, execa_1.default.command(installCommand, { stdio: stdio })];
            case 1:
                _e.sent();
                launchCommand = "adb shell monkey -p \"" + packageName + "\" -c android.intent.category.LAUNCHER 1";
                return [4 /*yield*/, execa_1.default.command(launchCommand, { stdio: stdio })];
            case 2:
                _e.sent();
                return [4 /*yield*/, (0, wait_for_1.waitFor)(500)];
            case 3:
                _e.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.runAndroid = runAndroid;
var runHandler = function (args) { return __awaiter(void 0, void 0, void 0, function () {
    var cwd, config, logger, runProject, restoreSimulatorUI, webSocketProcess, jestConfigPath, jestCommandArgs, reportDirPath, outputFile, jestCommand, error_1;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                cwd = process.cwd();
                return [4 /*yield*/, (0, config_1.getConfig)(args.config)];
            case 1:
                config = _b.sent();
                logger = new logger_1.Logger(config.debug);
                runProject = args.platform === 'ios' ? exports.runIOS : exports.runAndroid;
                restoreSimulatorUI = args.platform === 'ios' && exports.restoreIOSUI;
                // Remove old report and screenshots
                return [4 /*yield*/, (0, report_1.cleanupReport)()];
            case 2:
                // Remove old report and screenshots
                _b.sent();
                return [4 /*yield*/, (0, screenshot_1.cleanupScreenshots)()];
            case 3:
                _b.sent();
                logger.print("[OWL - CLI] Starting websocket server.");
                webSocketProcess = execa_1.default.command('node scripts/websocket-server.js', {
                    stdio: 'inherit',
                    cwd: path_1.default.join(__dirname, '..', '..'),
                    env: {
                        OWL_DEBUG: String(!!config.debug),
                    },
                });
                logger.print("[OWL - CLI] Running tests on " + args.platform + ".");
                return [4 /*yield*/, runProject(config, logger)];
            case 4:
                _b.sent();
                jestConfigPath = path_1.default.join(__dirname, '..', 'jest-config.json');
                jestCommandArgs = [
                    'jest',
                    "--config=" + jestConfigPath,
                    "--roots=" + cwd,
                    '--runInBand',
                ];
                if (!config.report) return [3 /*break*/, 6];
                reportDirPath = path_1.default.join(cwd, '.owl', 'report');
                outputFile = path_1.default.join(reportDirPath, 'jest-report.json');
                return [4 /*yield*/, fs_1.promises.mkdir(reportDirPath, { recursive: true })];
            case 5:
                _b.sent();
                jestCommandArgs.push("--json --outputFile=" + outputFile);
                _b.label = 6;
            case 6:
                jestCommand = jestCommandArgs.join(' ');
                logger.print("[OWL - CLI] " + (args.update
                    ? '(Update mode) Updating baseline images'
                    : '(Tests mode) Will compare latest images with the baseline') + ".");
                logger.info("[OWL - CLI] Will use the jest config localed at " + jestConfigPath + ".");
                logger.info("[OWL - CLI] Will set the jest root to " + process.cwd() + ".");
                _b.label = 7;
            case 7:
                _b.trys.push([7, 9, 10, 15]);
                return [4 /*yield*/, execa_1.default.commandSync(jestCommand, {
                        stdio: 'inherit',
                        env: {
                            OWL_PLATFORM: args.platform,
                            OWL_DEBUG: String(!!config.debug),
                            OWL_UPDATE_BASELINE: String(!!args.update),
                            OWL_IOS_SIMULATOR: (_a = config.ios) === null || _a === void 0 ? void 0 : _a.device,
                        },
                    })];
            case 8:
                _b.sent();
                return [3 /*break*/, 15];
            case 9:
                error_1 = _b.sent();
                // Throw the error again, so that ci will fail when the jest tests fail
                throw error_1;
            case 10:
                if (!config.report) return [3 /*break*/, 12];
                return [4 /*yield*/, (0, report_1.generateReport)(logger, args.platform)];
            case 11:
                _b.sent();
                _b.label = 12;
            case 12:
                webSocketProcess.kill();
                if (!restoreSimulatorUI) return [3 /*break*/, 14];
                return [4 /*yield*/, restoreSimulatorUI(config, logger)];
            case 13:
                _b.sent();
                _b.label = 14;
            case 14:
                logger.print("[OWL - CLI] Tests completed on " + args.platform + ".");
                if (args.update) {
                    logger.print("[OWL - CLI] All baseline images for " + args.platform + " have been updated successfully.");
                }
                return [7 /*endfinally*/];
            case 15: return [2 /*return*/];
        }
    });
}); };
exports.runHandler = runHandler;
