"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var fs_1 = require("fs");
var execa_1 = __importDefault(require("execa"));
var logger_1 = require("../logger");
var configHelpers = __importStar(require("./config"));
var run = __importStar(require("./run"));
var reportHelpers = __importStar(require("../report"));
describe('run.ts', function () {
    var logger = new logger_1.Logger();
    var bundleIdIOS = 'org.reactjs.native.example.RNDemo';
    var mockBundleIdResponse = { stdout: bundleIdIOS };
    var mkdirMock = jest.spyOn(fs_1.promises, 'mkdir');
    jest
        .spyOn(process, 'cwd')
        .mockReturnValue('/Users/johndoe/Projects/my-project');
    var execKillMock = {
        kill: jest.fn(),
    };
    var execMock = jest.spyOn(execa_1.default, 'command').mockImplementation();
    beforeEach(function () {
        mkdirMock.mockReset();
        execMock.mockReset().mockReturnValue(execKillMock);
    });
    describe('runIOS', function () {
        it('runs an iOS project - with the default build command', function () { return __awaiter(void 0, void 0, void 0, function () {
            var cwd, plistPath, config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cwd = path_1.default.join(process.cwd(), '/ios/build/Build/Products/Debug-iphonesimulator');
                        plistPath = path_1.default.join(cwd, 'RNDemo.app', 'Info.plist');
                        execMock.mockResolvedValueOnce(mockBundleIdResponse);
                        config = {
                            ios: {
                                workspace: 'ios/RNDemo.xcworkspace',
                                scheme: 'RNDemo',
                                configuration: 'Debug',
                                device: 'iPhone Simulator',
                            },
                        };
                        return [4 /*yield*/, run.runIOS(config, logger)];
                    case 1:
                        _a.sent();
                        expect(execMock).toHaveBeenNthCalledWith(1, "./PlistBuddy -c 'Print CFBundleIdentifier' " + plistPath, { cwd: '/usr/libexec', shell: true });
                        expect(execMock).toHaveBeenNthCalledWith(2, 'xcrun simctl status_bar iPhone\\ Simulator override --time 9:41', { cwd: cwd, stdio: 'ignore' });
                        expect(execMock).toHaveBeenNthCalledWith(3, 'xcrun simctl install iPhone\\ Simulator RNDemo.app', { cwd: cwd, stdio: 'ignore' });
                        expect(execMock).toHaveBeenNthCalledWith(4, "xcrun simctl launch iPhone\\ Simulator " + bundleIdIOS, { stdio: 'ignore' });
                        return [2 /*return*/];
                }
            });
        }); });
        it('runs an iOS project - with a custom build command and binaryPath', function () { return __awaiter(void 0, void 0, void 0, function () {
            var binaryPath, cwd, config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        binaryPath = 'custom/path/RNDemo.app';
                        cwd = path_1.default.dirname(binaryPath);
                        execMock.mockResolvedValueOnce(mockBundleIdResponse);
                        config = {
                            ios: {
                                buildCommand: "echo 'Hello World'",
                                binaryPath: binaryPath,
                                device: 'iPhone Simulator',
                            },
                        };
                        return [4 /*yield*/, run.runIOS(config, logger)];
                    case 1:
                        _a.sent();
                        expect(execMock).toHaveBeenNthCalledWith(1, "./PlistBuddy -c 'Print CFBundleIdentifier' " + binaryPath + "/Info.plist", { cwd: '/usr/libexec', shell: true });
                        expect(execMock).toHaveBeenNthCalledWith(2, 'xcrun simctl status_bar iPhone\\ Simulator override --time 9:41', { cwd: cwd, stdio: 'ignore' });
                        expect(execMock).toHaveBeenNthCalledWith(3, 'xcrun simctl install iPhone\\ Simulator RNDemo.app', { cwd: cwd, stdio: 'ignore' });
                        expect(execMock).toHaveBeenNthCalledWith(4, "xcrun simctl launch iPhone\\ Simulator " + bundleIdIOS, { stdio: 'ignore' });
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('restoreIOSUI', function () {
        it('cleans up an iOS project', function () { return __awaiter(void 0, void 0, void 0, function () {
            var cwd, config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cwd = path_1.default.join(process.cwd(), '/ios/build/Build/Products/Debug-iphonesimulator');
                        execMock.mockResolvedValueOnce(mockBundleIdResponse);
                        config = {
                            ios: {
                                workspace: 'ios/RNDemo.xcworkspace',
                                scheme: 'RNDemo',
                                configuration: 'Debug',
                                device: 'iPhone Simulator',
                            },
                        };
                        return [4 /*yield*/, run.restoreIOSUI(config, logger)];
                    case 1:
                        _a.sent();
                        expect(execMock).toHaveBeenNthCalledWith(1, 'xcrun simctl status_bar iPhone\\ Simulator clear', { cwd: cwd, stdio: 'ignore' });
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('runAndroid', function () {
        var cwd = path_1.default.join(process.cwd(), '/android/app/build/outputs/apk/release');
        it('runs an Android project - with the default build command', function () { return __awaiter(void 0, void 0, void 0, function () {
            var appPath, config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        appPath = path_1.default.join(cwd, 'app-release.apk');
                        config = {
                            android: {
                                packageName: 'com.rndemo',
                                buildType: 'Release',
                            },
                        };
                        return [4 /*yield*/, run.runAndroid(config, logger)];
                    case 1:
                        _a.sent();
                        expect(execMock).toHaveBeenNthCalledWith(1, "adb install -r " + appPath, {
                            stdio: 'ignore',
                        });
                        expect(execMock).toHaveBeenNthCalledWith(2, "adb shell monkey -p \"com.rndemo\" -c android.intent.category.LAUNCHER 1", { stdio: 'ignore' });
                        return [2 /*return*/];
                }
            });
        }); });
        it('runs an Android project - with a custom build command', function () { return __awaiter(void 0, void 0, void 0, function () {
            var binaryPath, config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        binaryPath = '/Users/Demo/Desktop/app-release.apk';
                        config = {
                            android: {
                                packageName: 'com.rndemo',
                                buildCommand: './gradlew example',
                                binaryPath: binaryPath,
                            },
                        };
                        return [4 /*yield*/, run.runAndroid(config, logger)];
                    case 1:
                        _a.sent();
                        expect(execMock).toHaveBeenNthCalledWith(1, "adb install -r " + binaryPath, {
                            stdio: 'ignore',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('runHandler', function () {
        var args = {
            platform: 'ios',
            config: './owl.config.json',
            update: false,
        };
        var config = {
            ios: {
                workspace: 'ios/RNDemo.xcworkspace',
                scheme: 'RNDemo',
                device: 'iPhone Simulator',
            },
            android: {
                packageName: 'com.rndemo',
                buildCommand: "echo 'Hello World'",
            },
        };
        var jestConfigPath = path_1.default.join(__dirname, '..', 'jest-config.json');
        var expectedJestCommand = "jest --config=" + jestConfigPath + " --roots=" + path_1.default.join(process.cwd()) + " --runInBand";
        var expectedJestCommandWithReport = expectedJestCommand + " --json --outputFile=/Users/johndoe/Projects/my-project/.owl/report/jest-report.json";
        var commandSyncMock = jest.spyOn(execa_1.default, 'commandSync');
        var mockGenerateReport = jest.spyOn(reportHelpers, 'generateReport');
        jest.spyOn(logger_1.Logger.prototype, 'print').mockImplementation();
        beforeEach(function () {
            commandSyncMock.mockReset();
            mockGenerateReport.mockReset();
        });
        it('runs an iOS project', function () { return __awaiter(void 0, void 0, void 0, function () {
            var mockRunIOS, mockRestoreIOSUI;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        jest
                            .spyOn(configHelpers, 'getConfig')
                            .mockResolvedValueOnce(__assign(__assign({}, config), { report: true }));
                        mockRunIOS = jest.spyOn(run, 'runIOS').mockResolvedValueOnce();
                        mockRestoreIOSUI = jest
                            .spyOn(run, 'restoreIOSUI')
                            .mockResolvedValueOnce();
                        mkdirMock.mockResolvedValue(undefined);
                        return [4 /*yield*/, run.runHandler(args)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, expect(mkdirMock).toHaveBeenCalled()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, expect(mockRunIOS).toHaveBeenCalled()];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, expect(commandSyncMock).toHaveBeenCalledTimes(1)];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, expect(commandSyncMock).toHaveBeenCalledWith(expectedJestCommandWithReport, {
                                env: {
                                    OWL_DEBUG: 'false',
                                    OWL_IOS_SIMULATOR: 'iPhone Simulator',
                                    OWL_PLATFORM: 'ios',
                                    OWL_UPDATE_BASELINE: 'false',
                                },
                                stdio: 'inherit',
                            })];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, expect(mockRestoreIOSUI).toHaveBeenCalled()];
                    case 6:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('runs an Android project', function () { return __awaiter(void 0, void 0, void 0, function () {
            var mockRunAndroid;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        jest.spyOn(configHelpers, 'getConfig').mockResolvedValueOnce(config);
                        mockRunAndroid = jest
                            .spyOn(run, 'runAndroid')
                            .mockResolvedValueOnce();
                        return [4 /*yield*/, run.runHandler(__assign(__assign({}, args), { platform: 'android' }))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, expect(mockRunAndroid).toHaveBeenCalled()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, expect(commandSyncMock).toHaveBeenCalledTimes(1)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, expect(commandSyncMock).toHaveBeenCalledWith(expectedJestCommand, {
                                env: {
                                    OWL_DEBUG: 'false',
                                    OWL_IOS_SIMULATOR: 'iPhone Simulator',
                                    OWL_PLATFORM: 'android',
                                    OWL_UPDATE_BASELINE: 'false',
                                },
                                stdio: 'inherit',
                            })];
                    case 4:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('runs with the update baseline flag on', function () { return __awaiter(void 0, void 0, void 0, function () {
            var mockRunIOS;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        jest.spyOn(configHelpers, 'getConfig').mockResolvedValueOnce(config);
                        mockRunIOS = jest.spyOn(run, 'runIOS').mockResolvedValueOnce();
                        return [4 /*yield*/, run.runHandler(__assign(__assign({}, args), { update: true }))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, expect(mockRunIOS).toHaveBeenCalled()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, expect(commandSyncMock).toHaveBeenCalledTimes(1)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, expect(commandSyncMock).toHaveBeenCalledWith(expectedJestCommand, {
                                env: {
                                    OWL_DEBUG: 'false',
                                    OWL_IOS_SIMULATOR: 'iPhone Simulator',
                                    OWL_PLATFORM: 'ios',
                                    OWL_UPDATE_BASELINE: 'true',
                                },
                                stdio: 'inherit',
                            })];
                    case 4:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('runs the scripts/websocket-server.js script', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        jest.spyOn(configHelpers, 'getConfig').mockResolvedValueOnce(config);
                        return [4 /*yield*/, run.runHandler(__assign({}, args))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, expect(execMock.mock.calls[0][0]).toEqual('node scripts/websocket-server.js')];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('runs generates the report if the config is set to on', function () { return __awaiter(void 0, void 0, void 0, function () {
            var caseConfig, mockRunIOS, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        caseConfig = __assign(__assign({}, config), { report: true });
                        jest.spyOn(configHelpers, 'getConfig').mockResolvedValueOnce(caseConfig);
                        mockRunIOS = jest.spyOn(run, 'runIOS').mockResolvedValueOnce();
                        commandSyncMock.mockRejectedValueOnce(undefined);
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 7]);
                        return [4 /*yield*/, run.runHandler(__assign(__assign({}, args), { update: true }))];
                    case 2:
                        _b.sent();
                        return [3 /*break*/, 7];
                    case 3:
                        _a = _b.sent();
                        return [4 /*yield*/, expect(mockRunIOS).toHaveBeenCalled()];
                    case 4:
                        _b.sent();
                        return [4 /*yield*/, expect(commandSyncMock).toHaveBeenCalledTimes(1)];
                    case 5:
                        _b.sent();
                        return [4 /*yield*/, expect(mockGenerateReport).toHaveBeenCalledTimes(1)];
                    case 6:
                        _b.sent();
                        return [3 /*break*/, 7];
                    case 7: return [2 /*return*/];
                }
            });
        }); });
        it('does not generate the report if the config is set to off', function () { return __awaiter(void 0, void 0, void 0, function () {
            var caseConfig, mockRunIOS, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        caseConfig = __assign(__assign({}, config), { report: false });
                        jest.spyOn(configHelpers, 'getConfig').mockResolvedValueOnce(caseConfig);
                        mockRunIOS = jest.spyOn(run, 'runIOS').mockResolvedValueOnce();
                        commandSyncMock.mockRejectedValueOnce(undefined);
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 9]);
                        return [4 /*yield*/, run.runHandler(__assign({}, args))];
                    case 2:
                        _b.sent();
                        return [3 /*break*/, 9];
                    case 3:
                        _a = _b.sent();
                        return [4 /*yield*/, expect(commandSyncMock).toHaveBeenCalledWith(expectedJestCommand, {
                                env: {
                                    OWL_DEBUG: 'false',
                                    OWL_IOS_SIMULATOR: 'iPhone Simulator',
                                    OWL_PLATFORM: 'ios',
                                    OWL_UPDATE_BASELINE: 'false',
                                },
                                stdio: 'inherit',
                            })];
                    case 4:
                        _b.sent();
                        return [4 /*yield*/, expect(mockRunIOS).toHaveBeenCalled()];
                    case 5:
                        _b.sent();
                        return [4 /*yield*/, expect(commandSyncMock).toHaveBeenCalledTimes(1)];
                    case 6:
                        _b.sent();
                        return [4 /*yield*/, expect(mkdirMock).not.toHaveBeenCalled()];
                    case 7:
                        _b.sent();
                        return [4 /*yield*/, expect(mockGenerateReport).not.toHaveBeenCalled()];
                    case 8:
                        _b.sent();
                        return [3 /*break*/, 9];
                    case 9: return [2 /*return*/];
                }
            });
        }); });
    });
});
